package com.cmx.wanhui.ui

import android.app.Activity
import android.content.ClipData
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.webkit.ValueCallback
import android.webkit.WebChromeClient
import android.webkit.WebView
import com.cmx.wanhui.R
import com.cmx.wanhui.constant.Events
import com.cmx.wanhui.utils.L
import com.lsxiao.apollo.core.Apollo
import com.lsxiao.apollo.core.annotations.Receive
import kotlinx.android.synthetic.main.fragment_dashboard.wv_loan
import kotlinx.android.synthetic.main.fragment_home.tv_te
import java.io.File
import java.io.IOException
import java.text.SimpleDateFormat
import java.util.Date

class ModeFragment : BaseFragment() {
    private var mUploadMessage: ValueCallback<Array<Uri>>? = null
    private var mCameraPhotoPath: String? = null
    private var size: Long = 0


    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_dashboard, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        setVebView(wv_loan!!)
        wv_loan!!.loadUrl("https://www.baidu.com/")//SERVER_URL
        showDialog()
        wv_loan!!.webChromeClient = PQChromeClient()
    }


    inner class PQChromeClient : WebChromeClient() {
        // For Android 5.0+
        override fun onShowFileChooser(
            view: WebView,
            filePath: ValueCallback<Array<Uri>>,
            fileChooserParams: FileChooserParams
        ): Boolean {
            // Double check that we don't have any existing callbacks
            if (mUploadMessage != null) {
                mUploadMessage!!.onReceiveValue(null)
            }
            mUploadMessage = filePath
            Log.e("FileCooserParams => ", filePath.toString())
            var takePictureIntent: Intent? = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
            if (takePictureIntent!!.resolveActivity(activity!!.packageManager) != null) {
                // Create the File where the photo should go
                var photoFile: File? = null
                try {
                    photoFile = createImageFile()
                    takePictureIntent.putExtra("PhotoPath", mCameraPhotoPath)
                } catch (ex: IOException) {
                    // Error occurred while creating the File
                    Log.e("test", "Unable to create Image File", ex)
                }

                // Continue only if the File was successfully created
                if (photoFile != null) {
                    mCameraPhotoPath = "file:" + photoFile.absolutePath
                    takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(photoFile))
                } else {
                    takePictureIntent = null
                }
            }
            val contentSelectionIntent = Intent(Intent.ACTION_GET_CONTENT)
            contentSelectionIntent.addCategory(Intent.CATEGORY_OPENABLE)
            contentSelectionIntent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true)
            contentSelectionIntent.type = "image/*"
            val intentArray: Array<Intent?>
            intentArray = takePictureIntent?.let { arrayOf(it) } ?: arrayOfNulls(2)
            val chooserIntent = Intent(Intent.ACTION_CHOOSER)
            chooserIntent.putExtra(Intent.EXTRA_INTENT, contentSelectionIntent)
            chooserIntent.putExtra(Intent.EXTRA_TITLE, "Image Chooser")
            chooserIntent.putExtra(Intent.EXTRA_INITIAL_INTENTS, intentArray)
            startActivityForResult(Intent.createChooser(chooserIntent, "Select images"), 1)
            return true
        }
    }

    @Throws(IOException::class)
    private fun createImageFile(): File {
        // Create an image file name
        val timeStamp = SimpleDateFormat("yyyyMMdd_HHmmss").format(Date())
        val imageFileName = "JPEG_" + timeStamp + "_"
        val storageDir =
            Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES)
        return File.createTempFile(
            imageFileName,  /* prefix */
            ".jpg",  /* suffix */
            storageDir /* directory */
        )
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        if (requestCode != INPUT_FILE_REQUEST_CODE || mUploadMessage == null) {
            super.onActivityResult(requestCode, resultCode, data)
            return
        }
        try {
            val file_path = mCameraPhotoPath!!.replace("file:", "")
            val file = File(file_path)
            size = file.length()
        } catch (e: Exception) {
            Log.e("Error!", "Error while opening image file" + e.localizedMessage)
        }
        if (data != null || mCameraPhotoPath != null) {
            var count = 1
            var images: ClipData? = null
            try {
                images = data!!.clipData
            } catch (e: Exception) {
                Log.e("Error!", e.localizedMessage)
            }
            if (images == null && data != null && data.dataString != null) {
                count = data.dataString!!.length
            } else if (images != null) {
                count = images.itemCount
            }
            var results = arrayOfNulls<Uri>(count)
            // Check that the response is a good one
            if (resultCode == Activity.RESULT_OK) {
                if (size != 0L) {
                    // If there is not data, then we may have taken a photo
                    if (mCameraPhotoPath != null) {
                        results = arrayOf(Uri.parse(mCameraPhotoPath))
                    }
                } else if (data!!.clipData == null) {
                    results = arrayOf(Uri.parse(data.dataString))
                } else {
                    for (i in 0 until images!!.itemCount) {
                        results[i] = images.getItemAt(i).uri
                    }
                }
            }
            //mUploadMessage!!.onReceiveValue(results)
            mUploadMessage = null
        }
    }

    /**
     * 二维码扫描返回
     */
    @Receive(Events.JS_OPEN_SCANQR_BACK)
    fun onQRBack(msg: String) {
        val jsString = "javascript:onQRBack($msg)"
        L.e("JS二维码扫描返回>>>>", jsString)
        wv_loan!!.evaluateJavascript(jsString) { }
    }

    companion object {
        private const val INPUT_FILE_REQUEST_CODE = 1
    }
}